import { Navigate, createBrowserRouter } from "react-router-dom";
import Login from "./views/Login";
import Dashboard from "./views/Dashboard";
import GuestLayout from "./components/GuestLayout";
import AdminLayout from "./components/AdminLayout";
import DefaultLayout from "./components/DefaultLayout";
import ItemForm from "./views/ItemForm";
import Draw from "./views/Draw";



const router = createBrowserRouter ([
    {
        path: '/',
        element: <GuestLayout />,
        children: [
            {
                path: '/',
                element: <Navigate to="/draw" />
            },
            {
                path: '/login',
                element: <Login />
            }
        ]
    },
    {
        path: '/',
        element: <AdminLayout />,
        children: [
            {
                path: '/dashboard',
                element: <Dashboard />
            },
            {
                path: '/dashboard/items/new',
                element: <ItemForm key="itemCreate" />
            },
            {
                path: '/dashboard/item/:id',
                element: <ItemForm key="itemUpdate" />
            }
        ]
    },
    {
        path: '/',
        element: <DefaultLayout />,
        children: [
            {
                path: '/draw',
                element: <Draw />
            },
        ]
    }
])

export default router;