import { useEffect, useState } from "react";
import vidSrc from "../assets/3starwish-single.mp4"
import gifSrc from "../assets/explosion.gif"
import axiosClient from "../axios-client";

export default function Draw() {
  


    const [showVideo, setShowVideo] = useState(false);
    
    const [showReset, setShowReset] = useState(false);

    const [showNumber, setShowNumber] = useState(false);
    const [randomNumbers, setRandomNumbers] = useState([]);

    const [prize, setPrize] = useState([]);
    const [selectedPrize, setSelectedPrize] = useState(null);

    const [quantity, setQuantity] = useState([]);
    const [selectedQuantity, setSelectedQuantity] = useState(null);
    const [selectedProbability, setSelectedProbability] = useState(null);

    const [itemId, setItemId] = useState([]);
    const [selectedItemId, setSelectedItemId] = useState(null);

    const [itemImage, setItemImage] = useState([]);
    const [selectedItemImage, setSelectedItemImage] = useState(null);

    const [picked, setPickedItem] = useState();

    const [winPrize, setWinPrize] = useState();

    const [totalProb, setTotalProb] = useState(null);
    const [buttonState, setButtonState] = useState(true);

    const [items, setItems] = useState([]);
    const [loading, setLoading] = useState(false);
    const [showGif, setShowGif] = useState(false);



    useEffect(() => {
      setLoading(true)
      axiosClient.get('/items')
      .then(({ data }) => {
        const extractedNumbers = data.data 
                                .filter(obj => obj.quantity > 0)
                                .map(obj => obj.probability); 
        const totalProbability = extractedNumbers.reduce((acc, curr) => acc + curr, 0);
        setTotalProb(totalProbability);
        const extractedPrize = data.data
                                .filter(obj => obj.quantity > 0)
                                .map(obj => obj.item); 
        const extractedQuantity = data.data
                                  .filter(obj => obj.quantity > 0)
                                  .map(obj => obj.quantity);
        const extractedItemId = data.data
                                .filter(obj => obj.quantity > 0)
                                .map(obj => obj.id);
        const extractedItemImage = data.data
                                .filter(obj => obj.quantity > 0)
                          .      map(obj => obj.image);
        setRandomNumbers(extractedNumbers);
        setPrize(extractedPrize);
        setQuantity(extractedQuantity);
        setItemId(extractedItemId);
        setItemImage(extractedItemImage);
        setLoading(false)
        setItems(data.data)
      })
      .catch(() => {
        setLoading(false)
      })
    }, [])
    

    const handleButtonClick = () => {
      setShowGif(false);
      console.log(totalProb);
        if (totalProb !== 1) {
          alert('The total probability of the prizes is not 100%, please do a backend check first');
          return;
        }
        setShowNumber(false);
        setShowVideo(true);
        setLoading(false);
        const newRandomNumber = Math.random(); // Generate a random number between 1 and 100
        let accumulatedProbability = 0;
        for (let i = 0; i < randomNumbers.length; i++) {
          accumulatedProbability += randomNumbers[i];
          if (newRandomNumber <= accumulatedProbability) {
            setSelectedPrize(prize[i]);
            setWinPrize(itemId[i]);
            setSelectedQuantity(quantity[i]);
            setSelectedItemId(itemId[i]);
            setSelectedProbability(randomNumbers[i]);
            setSelectedItemImage(itemImage[i]);
            setPickedItem()
            break;
          }
        }
    };


    const handleVideoEnd = () => {
      if(!autoDraw) {
        const updatedQuantity = selectedQuantity - 1;
        axiosClient.put('/items/'+selectedItemId, {quantity: updatedQuantity, item: selectedPrize, probability: selectedProbability})
      }
        setShowVideo(false);
        setShowNumber(true);
        setShowGif(true);
        setShowReset(true);
        const timeout = setTimeout(() => {
          setShowGif(false);
        }, 1500);
    };

    const handleDrawAgain = () => {
      window.location.reload();
    };

    return (
        <div className="__drawBox">
            {showGif && (
              <div className="gif-container">
                <img
                  className="gif fade-in"
                  src={gifSrc}
                  alt="Loading GIF"
                />
              </div>
            )}
            <div className={`number ${showNumber ? 'fade-in' : ''}`}>
              {showNumber && (
              <>
              <div>
                  <img src={`http://127.0.0.1:8000${selectedItemImage}`} alt="" />
              </div>
              <div style={{ fontSize: '50px', fontWeight: 'bold', lineHeight: '50px', color: '#fff', letterSpacing: '10px', textTransform: 'uppercase', textAlign: 'center'}}>
                  {selectedPrize}
              </div>
              </>
            )}
           </div>
            {loading && (
              <div>Loading ...</div>
            )}
            {!showVideo && !showReset &&(
                <div style={{ marginTop: '50px' }}>
                    <button className="btn btn-secondary customBtn" onClick={handleButtonClick}>DRAW</button>
                </div>
            )}
            {!showVideo && showReset &&(
                <div style={{ marginTop: '50px' }}>
                    <button className="btn btn-secondary customBtn" onClick={handleDrawAgain}>RELOAD</button>
                </div>
            )}
            {showVideo && (
                <div style={{ height: '100vh', overflow: 'hidden'}}> 
                    <video src={vidSrc} onEnded={handleVideoEnd} autoPlay />
                </div>
            )}
        </div>
    )
}